# -*- coding: utf-8 -*-
'''
   "key":"OpenCPN 5.10.0-0+860222c",
   "name":"OpenCPN 5.10.0-0+860222c",
   "version":"5.10.0-0+860222c",
   "install_date":"2024-08-12 00:00:00",
   "install_location":"C:\\Program Files (x86)\\OpenCPN",
   "uninstall_string":"\"C:\\Program Files (x86)\\OpenCPN\\Uninstall 5.10.0-0+860222c.exe\"",
   "publisher":"opencpn.org",
   "system_component":0,
   "win64":False   
   
'''   

from setuphelpers import *


def install():
    bin_name = glob.glob("opencpn_*_setup.exe")[0]
    bin_version = bin_name.split("_")[1].split("+")[0]
    bin_key = bin_name.rsplit("_")[-2].rsplit(".")[-1]
    app_uninstallkey = "OpenCPN " + bin_version + "+" + bin_key
    
    # Uninstalling other versions of the software
    for to_uninstall in installed_softwares("opencpn"):
        if Version(to_uninstall["version"]) != Version(control.get_software_version()) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            try:
                killalltasks(ensure_list(control.impacted_process))
                quiet_uninstall_string = (installed_softwares(uninstallkey=to_uninstall["key"])[0]["uninstall_string"] + r'/S')
                run(quiet_uninstall_string)
                wait_uninstallkey_absent(to_uninstall["key"])
            except Exception as e: 
                print(e)
                print("Remove failed: %s (%s)\nContinuing..." % (to_uninstall["name"], to_uninstall["version"]))

    install_exe_if_needed(
        bin_name,
        silentflags="/S",
        key= app_uninstallkey,
        min_version="",
        timeout=600,
        accept_returncodes=[0, 3010, 1223],
    )
    
    # Adding QuietUninstallString
    quiet_uninstall_string = installed_softwares(uninstallkey=app_uninstallkey)[0]["uninstall_string"] + " /S"
    register_uninstall(app_uninstallkey, quiet_uninstall_string=quiet_uninstall_string)
